## TI-RSLK Debug Application

Exercise basic robot functions using the GUI interface. Use this tool for initial testing and sanity checking. The test program will automatically download when the TI-RSLK is connected over USB. Additional tabs at top provide tests for some TI-RSLK accessories. 

---

**Bump Switches**

TI-RSLK includes 6 forward mounted bump switches. When bump switches are pressed it should be indicated on the GUI. Red indicates logic LOW, Black indicates logic HIGH. The switches are connected to the MSP432 LaunchPad as follows:

- Bump 0 connected to P4.0 (J3)
- Bump 1 connected to P4.2 (J3)
- Bump 2 connected to P4.3 (J1)
- Bump 3 connected to P4.5 (J3)
- Bump 4 connected to P4.6 (J1)
- Bump 5 connected to P4.7 (J3)

**Line Sensor**

TI-RSLK has a IR reflectance sensor mounted to the bottom. When IR thresholds have been changed in front of line sensor it should be indicated on the GUI. Red indicates no reflectance detected, Black indicates a reflectance is detected. The line sensor is connected to the MSP432 as follows: 

- Reflectance0 connected to P7.0 (J5)
- Reflectance1 connected to P7.1 (J5)
- Reflectance2 connected to P7.2 (J5)
- Reflectance3 connected to P7.3 (J5)
- Reflectance4 connected to P7.4 (J5)
- Reflectance5 connected to P7.5 (J5)
- Reflectance6 connected to P7.6 (J5)
- Reflectance7 connected to P7.7 (J5)

**Motor Control**

The motor duty cycles (PWM values) can be adjusted using the GUI sliders or the left and right pushbuttons on the MSP432. Reverse the motor direction by toggling the respective radio buttons. The motors are connected to the MSP432 LaunchPad as follows:

- Left Motor PWM connected to P2.7 (J4)
- Left Motor DIR connected to P5.4 (J3)
- Left Motor nSLP connected P3.7 (J4)
- Right Motor PWM connected to P2.6 (J4)
- Right Motor DIR connected to P5.5 (J3)
- Right Motor nSLP connected to P3.6 (J2)


**Encoders**

Each motor encoder should to be connected to the MSP432 as follows:

- Left Encoder A connected to P10.5 (J5)
- Left Encoder B connected to P5.2 (J2)
- Right Encoder A connected to P10.4 (J5)
- Right Encoder B connected to P5.0 (J2)
  
Pololu encoder has 12 counts per revolution (counting all 4 edges). The motor has a gearbox with a 120:1 ratio. This gives 12*120 = 1440 counts per revolution of the wheel. Since we are only counting one edge of the encoder we need to divide by 4 for a total of 360 counts per revolution.


**Additional Resources**

This tool is created with MSP432 Driver Library. Source code for GUI and firmware are available. 

Created in collaboration with UCF TI Innovation Lab.

